classification
Title: Fixing links in documentation
Type: Stage:
Components: Documentation Versions: Python 3.6, Python 3.5
process
Status: open Resolution:
Dependencies: Superseder:
Assigned To: docs@python Nosy List: CuriousLearner, Mariatta, SilentGhost, barry, docs@python, georg.brandl, gvanrossum, j1m, larry, martin.panter, matrixise, orsenthil, python-dev, r.david.murray, serhiy.storchaka, tim.peters, zach.ware
Priority: normal Keywords: needs review, patch

Created on 2015-12-19 13:09 by SilentGhost, last changed 2017-08-08 11:16 by larry.

Files
File name Uploaded Description Edit
linkcheck.diff SilentGhost, 2015-12-19 13:08 review
output.txt SilentGhost, 2015-12-19 13:10 make linkcheck output after applying the patch
Pull Requests
URL Status Linked Edit
PR 1933 open CuriousLearner, 2017-06-03 20:05
PR 2765 Jim Ferrara, 2017-07-25 13:49
PR 2873 merged Mariatta, 2017-07-25 23:19
PR 2967 merged Mariatta, 2017-08-01 02:41
PR 2968 merged Mariatta, 2017-08-01 02:43
PR 2969 merged Mariatta, 2017-08-01 02:43
Messages (39)
msg256728 - (view) Author: SilentGhost (SilentGhost) * Date: 2015-12-19 13:08
I've run 'make linkcheck' on Doc and it highlighted a number of faulty links in documentation. I've tried fixing some of them and here is the resulting patch. It's a bit too long and touches many files, so to summarise:

* Most changes are http->https redirect (many from wikipedia and microsoft, but some from independent project)
* New domains, sometimes without redirect or any indication of how to find the same information. 
* Completely new locations, only discoverable via search engine.
* Few dead links, that I removed.

I'm going to attach output.txt that is produced after running linkcheck with this patch applied, it is about three time smaller than the original one and has this types of issues:

* Dead links in licenses
* Internal redirects to versioned text
* Many python.org links in whatsnew/ that I don't know what to do about
* Spurious bad links
msg260905 - (view) Author: Roundup Robot (python-dev) Date: 2016-02-26 18:38
New changeset ce5ef48b5140 by Georg Brandl in branch '3.5':
Closes #25910: fix dead and permanently redirected links in the docs. Thanks to SilentGhost for the patch.
https://hg.python.org/cpython/rev/ce5ef48b5140
msg260906 - (view) Author: Georg Brandl (georg.brandl) * (Python committer) Date: 2016-02-26 18:41
Reopening, for fixing the rest of the broken ones.
msg260949 - (view) Author: Martin Panter (martin.panter) * (Python committer) Date: 2016-02-27 23:03
BTW it looks like the suspicious.csv file needs updating to compensate for this change:

http://buildbot.python.org/all/builders/Docs%203.5/builds/654/steps/suspicious/logs/stdio

WARNING: [using/unix:31] ":Packaging" found in "https://en.opensuse.org/Portal:Packaging"
WARNING: Found 1/297 unused rules:
using/unix,,:Packaging,http://en.opensuse.org/Portal:Packaging
msg260969 - (view) Author: SilentGhost (SilentGhost) * Date: 2016-02-28 07:42
Perhaps, I'm misreading the log output, but it seems to me that it's Doc/tools/susp-ignored.csv that needs updating. Here is the attached patch.
msg260986 - (view) Author: Roundup Robot (python-dev) Date: 2016-02-28 20:13
New changeset 8f8e86ea3abb by Georg Brandl in branch '3.5':
Update susp-ignore file (#25910).
https://hg.python.org/cpython/rev/8f8e86ea3abb
msg263173 - (view) Author: Roundup Robot (python-dev) Date: 2016-04-11 09:39
New changeset ce721df212cf by Serhiy Storchaka in branch '3.5':
Issue #25910: Fixed dead links in the docs.
https://hg.python.org/cpython/rev/ce721df212cf

New changeset 14e00e7e4d51 by Georg Brandl in branch '2.7':
Closes #25910: fix dead and permanently redirected links in the docs. Thanks to SilentGhost for the patch.
https://hg.python.org/cpython/rev/14e00e7e4d51

New changeset 00addbb47c5c by Serhiy Storchaka in branch '2.7':
Issue #25910: Fixed dead links in the docs.
https://hg.python.org/cpython/rev/00addbb47c5c

New changeset 15c4557af8e0 by Serhiy Storchaka in branch 'default':
Issue #25910: Fixed dead links in the docs.
https://hg.python.org/cpython/rev/15c4557af8e0
msg263174 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-04-11 09:40
Following dead links left:

Doc/library/xmlrpc.client.rst
(line   42) broken    http://ontosys.com/xml-rpc/extensions.php - <urlopen error timed out>

Doc/license.rst
(line   22) broken    http://www.zope.com/ - <urlopen error [Errno -2] Name or service not known>
(line  131) broken    http://www.pythonlabs.com/logos.html - HTTP Error 404: Not Found

Doc/using/windows.rst
(line  271) broken    http://www.swaroopch.com/notes/python/#install_windows - Anchor 'install_windows' not found

Doc/whatsnew/2.1.rst
(line  543) broken    http://www.vex.net/parnassus/ - HTTP Error 404: Not Found

Doc/whatsnew/2.6.rst
(line  174) broken    http://svn.python.org/view/tracker/importer/ - HTTP Error 404: Not Found
(line  193) broken    http://svn.python.org/view/tracker/importer/ - HTTP Error 404: Not Found

Doc/whatsnew/2.7.rst
(line 1529) broken    http://www.openssl.org/docs/apps/ciphers.html#CIPHER_LIST_FORMAT - Anchor 'CIPHER_LIST_FORMAT' not found
(line 1618) broken    http://www.openssl.org/docs/apps/ciphers.html#CIPHER_LIST_FORMAT - Anchor 'CIPHER_LIST_FORMAT' not found
msg263177 - (view) Author: SilentGhost (SilentGhost) * Date: 2016-04-11 10:31
Licence text shouldn't be touched, I think.

http://www.openssl.org/docs/apps/ciphers.html#CIPHER_LIST_FORMAT became https://www.openssl.org/docs/manmaster/apps/ciphers.html#CIPHER-LIST-FORMAT

If Martin still have the importer code somewhere, he probably could provide an up to date link.
msg263179 - (view) Author: Martin Panter (martin.panter) * (Python committer) Date: 2016-04-11 11:33
The bug tracker importer still exists if you know what revision to look it up in: <http://svn.python.org/view/tracker/importer/?pathrev=88980>
msg263182 - (view) Author: Roundup Robot (python-dev) Date: 2016-04-11 14:38
New changeset bb10867ffe28 by Serhiy Storchaka in branch '3.5':
Issue #25910: Fixed more links in the docs.
https://hg.python.org/cpython/rev/bb10867ffe28

New changeset 61c7deea9e6a by Serhiy Storchaka in branch '2.7':
Issue #25910: Fixed more links in the docs.
https://hg.python.org/cpython/rev/61c7deea9e6a

New changeset e3c9a47a83fb by Serhiy Storchaka in branch 'default':
Issue #25910: Fixed more links in the docs.
https://hg.python.org/cpython/rev/e3c9a47a83fb
msg263183 - (view) Author: SilentGhost (SilentGhost) * Date: 2016-04-11 14:40
Serhiy, the OpenSSL links are now https
msg263185 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-04-11 14:56
Fixed links to "A Byte of Python" and OpenSSL.

Not fixed dead links:

http://www.zope.com/
http://www.pythonlabs.com/logos.html (http://www.pythonlabs.com/ exists but is not too useful)
http://www.vex.net/parnassus/ (looks as this project is dead)
http://ontosys.com/xml-rpc/extensions.php (sad, this was a specification)
http://svn.python.org/view/tracker/importer/ (removed in r88981 and not moved to https://hg.python.org/tracker)
msg263186 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-04-11 14:59
> Serhiy, the OpenSSL links are now https

They works with http.

Some links (including python.org) are now redirected from http to https. It may be worth to add https explicitly.
msg263198 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-04-11 18:36
For XML-RPC extensions we can use a web archive: https://web.archive.org/web/20130120074804/http://ontosys.com/xml-rpc/extensions.php. There are precedences of using it for other dead links.

Opened separate issue26736 for https-zation.
msg263305 - (view) Author: Roundup Robot (python-dev) Date: 2016-04-13 04:32
New changeset 4b65bee79dab by Georg Brandl in branch '2.7':
Update susp-ignore file (#25910).
https://hg.python.org/cpython/rev/4b65bee79dab
msg265677 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-05-16 07:37
XML-RPC link was fixed in issue26889 (using the a web archive).

Left links are http://www.zope.com/, http://www.pythonlabs.com/logos.html, and links to dead projects. What can we do with Zope and PythonLabs links?
msg265685 - (view) Author: Senthil Kumaran (orsenthil) * (Python committer) Date: 2016-05-16 08:30
zope should be http://www.zope.org/
The pythonlabs link could be removed.
The logos at pythonlabs link does not exist. Reference for pythonlab exists in a humorous form  here: http://www.pythonlabs.com/
msg265708 - (view) Author: SilentGhost (SilentGhost) * Date: 2016-05-16 16:12
Does it not matter that the link to pythonlabs is a part of the official license text? Besides, it's not an actual html a tag, but rather a verbatim text, surely the only correction here is to make sure that the linkcheck doesn't check links within pre, code and similar tags.
msg265732 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2016-05-16 20:40
> zope should be http://www.zope.org/

Isn't this is a different legal entity?
msg265766 - (view) Author: Senthil Kumaran (orsenthil) * (Python committer) Date: 2016-05-17 13:58
On Mon, May 16, 2016 at 08:40:51PM +0000, Serhiy Storchaka wrote:
> > zope should be http://www.zope.org/
> 
> Isn't this is a different legal entity?

Is it? I don't know. I can find no references to zope.com being
different than zope.org in my google searches and from wikipedia
article.
msg270768 - (view) Author: St├ęphane Wirtel (matrixise) * Date: 2016-07-18 16:02
maybe we can continue on this issue and close it asap.

what do you think ?
msg295068 - (view) Author: Sanyam Khurana (CuriousLearner) * Date: 2017-06-03 07:04
Hi,

If this work is not being actively worked on, can I work on this and fix the remaining links?
msg295073 - (view) Author: SilentGhost (SilentGhost) * Date: 2017-06-03 09:39
>  can I work on this and fix the remaining links?
Please do.
msg295075 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2017-06-03 13:08
I think only lawyers or people related to the Zope Corporation and the BeOpen PythonLabs team can help with fixing the links to http://www.zope.com/ and http://www.pythonlabs.com/logos.html.
msg295078 - (view) Author: Barry A. Warsaw (barry) * (Python committer) Date: 2017-06-03 14:52
Adding Jim Fulton (for Zope) and Guido (for Pythonlabs).  I don't know who owns the former, but I'm fairly sure Guido owns the pythonlabs domain.
msg295091 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2017-06-03 17:30
www.pythonlabs.com still exists. (The www. is mandatory.) And zope.org also
still works.

On Jun 3, 2017 7:52 AM, "Barry A. Warsaw" <report@bugs.python.org> wrote:

>
> Barry A. Warsaw added the comment:
>
> Adding Jim Fulton (for Zope) and Guido (for Pythonlabs).  I don't know who
> owns the former, but I'm fairly sure Guido owns the pythonlabs domain.
>
> ----------
> nosy: +gvanrossum, j1m
>
> _______________________________________
> Python tracker <report@bugs.python.org>
> <http://bugs.python.org/issue25910>
> _______________________________________
>
msg295092 - (view) Author: Jim Fulton (j1m) * (Python committer) Date: 2017-06-03 17:37
Zope Corporation no longer exists. Any references to it should be in the past tense and without a link.

(The http://www.zope.org is for the Zope Foundation, which is a different thing.)
msg295100 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2017-06-03 19:57
> www.pythonlabs.com still exists. (The www. is mandatory.)

But http://www.pythonlabs.com/logos.html doesn't. And since this link is a part of the BeOpen.com license, changing it changes the license. I don't know whether this part of the license is valid if the referred resource no longer available.
msg295104 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2017-06-03 20:26
I can make the logos.html page appear. Just keep the link in the license as
it is.

On Jun 3, 2017 1:05 PM, "Sanyam Khurana" <report@bugs.python.org> wrote:

>
> Changes by Sanyam Khurana <sanyam.khurana01@gmail.com>:
>
>
> ----------
> pull_requests: +2010
>
> _______________________________________
> Python tracker <report@bugs.python.org>
> <http://bugs.python.org/issue25910>
> _______________________________________
>
msg295148 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2017-06-04 23:13
I've done what I can for the logos: http://www.pythonlabs.com/logos.html
msg295163 - (view) Author: Serhiy Storchaka (serhiy.storchaka) * (Python committer) Date: 2017-06-05 04:42
Thank you!

What is left:

* Rewrite the text of license.rst for referring the Zope Corporation in the past tense and remove the link (and maybe add the reference to the Zope Foundation if it is related).

* Mark historical links http://www.vex.net/parnassus/ and http://svn.python.org/view/tracker/importer/ as dead.
msg295200 - (view) Author: Guido van Rossum (gvanrossum) * (Python committer) Date: 2017-06-05 15:29
I suggest the following replacement for that paragraph in Doc/license.txt, as well as in LICENSE:

In May 2000, Guido and the Python core development team moved to
BeOpen.com to form the BeOpen PythonLabs team.  In October of the same
year, the PythonLabs team moved to Digital Creations, which became
Zope Corporation.  In 2001, the Python Software Foundation (PSF, see
https://www.python.org/psf/) was formed, a non-profit organization
created specifically to own Python-related Intellectual Property.
Zope Corporation was a sponsoring member of the PSF.
msg295201 - (view) Author: Jim Fulton (j1m) * (Python committer) Date: 2017-06-05 15:32
+1
msg299575 - (view) Author: Mariatta Wijaya (Mariatta) * (Python committer) Date: 2017-07-31 18:16
New changeset 8474d87165593bac2bc231287f42c4cff3fd6aaf by Mariatta in branch 'master':
bpo-25910: Update LICENSE (GH-2873)
https://github.com/python/cpython/commit/8474d87165593bac2bc231287f42c4cff3fd6aaf
msg299592 - (view) Author: Mariatta Wijaya (Mariatta) * (Python committer) Date: 2017-08-01 02:53
New changeset f6306e737203ac1bf1717bbf62bc58dac24b68db by Mariatta in branch '3.5':
bpo-25910: Update LICENSE (GH-2873) (GH-2968)
https://github.com/python/cpython/commit/f6306e737203ac1bf1717bbf62bc58dac24b68db
msg299593 - (view) Author: Mariatta Wijaya (Mariatta) * (Python committer) Date: 2017-08-01 02:55
New changeset b3c7d37c5ac8dbba4f1ebcf279bfceb570fb6c19 by Mariatta in branch '2.7':
bpo-25910: Update LICENSE (GH-2873) (GH-2969)
https://github.com/python/cpython/commit/b3c7d37c5ac8dbba4f1ebcf279bfceb570fb6c19
msg299594 - (view) Author: Mariatta Wijaya (Mariatta) * (Python committer) Date: 2017-08-01 02:59
New changeset 330cdac5174e3dc6c1deb876bc12a39d7af9af84 by Mariatta in branch '3.6':
bpo-25910: Update LICENSE (GH-2873) (GH-2967)
https://github.com/python/cpython/commit/330cdac5174e3dc6c1deb876bc12a39d7af9af84
msg299905 - (view) Author: Larry Hastings (larry) * (Python committer) Date: 2017-08-08 11:16
New changeset 14167c9524bd65f231dfd85edc0b938c4781f42a by Larry Hastings (Mariatta) in branch '3.5':
bpo-25910: Update LICENSE (GH-2873) (GH-2968)
https://github.com/python/cpython/commit/14167c9524bd65f231dfd85edc0b938c4781f42a
History
Date User Action Args
2017-08-08 11:16:25larrysetnosy: + larry
messages: + msg299905
2017-08-01 02:59:52Mariattasetmessages: + msg299594
2017-08-01 02:55:22Mariattasetmessages: + msg299593
2017-08-01 02:53:45Mariattasetmessages: + msg299592
2017-08-01 02:43:15Mariattasetpull_requests: + pull_request3017
2017-08-01 02:43:01Mariattasetpull_requests: + pull_request3016
2017-08-01 02:41:45Mariattasetpull_requests: + pull_request3015
2017-07-31 18:16:17Mariattasetnosy: + Mariatta
messages: + msg299575
2017-07-25 23:19:56Mariattasetpull_requests: + pull_request2924
2017-07-25 13:49:19Jim Ferrarasetpull_requests: + pull_request2917
2017-06-05 15:32:49j1msetmessages: + msg295201
2017-06-05 15:29:09gvanrossumsetmessages: + msg295200
2017-06-05 04:42:06serhiy.storchakasetmessages: + msg295163
2017-06-04 23:13:43gvanrossumsetmessages: + msg295148
2017-06-03 20:26:18gvanrossumsetmessages: + msg295104
2017-06-03 20:05:23CuriousLearnersetpull_requests: + pull_request2010
2017-06-03 19:57:57serhiy.storchakasetmessages: + msg295100
2017-06-03 17:37:22j1msetmessages: + msg295092
2017-06-03 17:30:42gvanrossumsetmessages: + msg295091
2017-06-03 14:52:13barrysetnosy: + gvanrossum, j1m
messages: + msg295078
2017-06-03 13:08:32serhiy.storchakasetmessages: + msg295075
2017-06-03 09:39:32SilentGhostsetmessages: + msg295073
2017-06-03 07:04:23CuriousLearnersetnosy: + CuriousLearner
messages: + msg295068
2016-07-18 16:02:11matrixisesetnosy: + matrixise
messages: + msg270768
2016-05-17 13:58:20orsenthilsetmessages: + msg265766
2016-05-16 20:40:51serhiy.storchakasetmessages: + msg265732
2016-05-16 16:12:38SilentGhostsetmessages: + msg265708
2016-05-16 08:30:07orsenthilsetnosy: + orsenthil
messages: + msg265685
2016-05-16 07:37:55serhiy.storchakasetmessages: + msg265677
2016-04-13 04:32:33python-devsetmessages: + msg263305
2016-04-11 18:36:20serhiy.storchakasetmessages: + msg263198
2016-04-11 15:00:54serhiy.storchakasetnosy: + tim.peters, barry
2016-04-11 14:59:41serhiy.storchakasetmessages: + msg263186
2016-04-11 14:56:47serhiy.storchakasetmessages: + msg263185
2016-04-11 14:40:19SilentGhostsetmessages: + msg263183
2016-04-11 14:38:56python-devsetmessages: + msg263182
2016-04-11 11:33:39martin.pantersetmessages: + msg263179
2016-04-11 10:31:21SilentGhostsetmessages: + msg263177
2016-04-11 09:50:05serhiy.storchakasetstatus: closed -> open
resolution: fixed ->
stage: resolved ->
2016-04-11 09:40:43serhiy.storchakasetnosy: + serhiy.storchaka
messages: + msg263174
2016-04-11 09:39:53python-devsetstatus: open -> closed
resolution: fixed
messages: + msg263173
2016-02-28 20:13:55python-devsetmessages: + msg260986
2016-02-28 07:42:56SilentGhostsetmessages: + msg260969
2016-02-27 23:03:17martin.pantersetnosy: + martin.panter
messages: + msg260949
2016-02-26 18:41:25georg.brandlsetstatus: closed -> open

nosy: + georg.brandl
messages: + msg260906

resolution: fixed -> (no value)
2016-02-26 18:38:13python-devsetstatus: open -> closed

nosy: + python-dev
messages: + msg260905

resolution: fixed
stage: patch review -> resolved
2016-02-26 18:19:40georg.brandlsetstatus: languishing -> open
2016-02-22 17:42:35SilentGhostsetstatus: open -> languishing
2015-12-19 13:10:03SilentGhostsetfiles: + output.txt
stage: needs patch -> patch review
2015-12-19 13:09:03SilentGhostcreate